/*
 * task06
 * [^GR[_^^b`ZT^XN
 * 
 */



#include "mirx68k.h"
#include "hard.h"

#define PI	3.1415926535f	/* ~ */
#define PI2	(PI*2.f)	/* 2 */
#define PIH	(PI/2.f)	/* /2 */

#define DT	0.03f		/* Tv[sec] */

#define D	0.0715f		/* ^C̒a[m] */

#define TIMER_RE 3		/* [^GR[_f[^ǗW[̃^C}[10msec] */

#define TC	D*PI*1000*60/56	/* ^C̉~[mm] */

#define RG	16.f	/* M */
#define PPR	400.f	/* ^C]ŔpX[pulse/r] */
#define BMIGI	0.11752155f 	/*ij ^CԊûP^Q [m] TOeXg */

#define BHIDARI	0.11733540f

#define CAREMIGI	360*5/(360*5-256)*360*2/717	/* 9803̔ */
#define CAREHIDARI	360*5/(360*5-223)

#define DEG	(180.f/PI)	/* 180/΁iʓx@̃f[^360@ɒj */
#define COEF	((PI/2*D)/(PPR*RG*DT))
#define KoMIGI	(COEF/BMIGI)*CAREMIGI	/**/
#define KoHIDARI	(COEF/BHIDARI)*CAREHIDARI	/**/

#define BT 11.f					/* ^C璆S܂ł̋[cm] */
#define CL 50					/* |[Ƃ̍^C̈ړ */
#define CR (50+BT*2*2)			/* |[Ƃ̉E^C̈ړ */


static float	om=0.f,				/* px[rad/s] */
				self_th=PI/2;			/* px[rad] */

void inzt06(){
	sys0(6,0x1010);
	sys2(6,TIMER_RE,0,0);	/* [^GR[_f[^ǗW[̓o^ */
	sys4(6);				/* [^GR[_W[̃^C}JEgXgbv */
	sys3(6,1);				/* [^GR[_W[̃JEgX^[g */
	
	sys8(6,1,0);			/* ^b`ZT̓f[^ */
	sys8(6,2,0);			/* E^C̃pX */
	sys8(6,3,0);			/* ^C̃pX */
	sys8(6,4,0);			/* E^C̐i񂾋̑a[cm] */
	sys8(6,5,0);			/* ^C̐i񂾋̑a[cm] */
	sys8(6,6,0);			/* E[^̃pX */
	sys8(6,7,0);			/* [^̃pX */
	sys8(6,8,0);			/* E^C̉] */
	sys8(6,9,0);			/* ^C̉] */
	sys8(6,10,(int)(self_th*DEG));	/* pp[] */
	sys8(6,11,0);			/* ␳̃[h 1:i 2:|Xg]() 3:|Xg](E) 4:|[T */
	sys8(6,12,0);			/* ڕWx [cm/sec] */
	sys8(6,13,180);			/* ړI␳p */
	sys8(6,14,0);			/* ڕWړ */
	sys8(6,15,0);
	sys8(6,16,0);
	sys8(6,17,0);
	sys8(6,18,0);
	sys8(6,19,0);
}

void nrmt06(){
	
}

void timt06(){
	int ts_data;
	float r_distance,r_pals;
	float l_distance,l_pals;
	int r,l;
	int mode,rp,lp;
	float om_old;
	int th_now,target_th;
	int tar_v,tar_pals;
	int i;
	int l_dis,r_dis,tar_dis,tar_rv,tar_lv;
	int tar_rpals,tar_lpals;

	RE_TS_DATA data;		/* dataRE_TS_DATA^ɐ錾*/
	
	data=re_ts_data();
	ts_data=data.ts;
	r_pals=sys9(6,6);
	l_pals=sys9(6,7);
	r=sys9(6,8);
	l=sys9(6,9);
	r_distance=sys9(6,4);
	l_distance=sys9(6,5);
	
	mode = sys9(6,11);
	tar_v = sys9(6,12);
	target_th = sys9(6,13);
	tar_dis = sys9(6,14);
	
	rp = sys9(4,3);
	lp = sys9(4,4);
	
	th_now=sys9(6,10);
	th_now=abs(th_now);
	
	
	r_pals = r_pals + data.r;
	l_pals = l_pals + data.l;

	if(r_pals >= 6400){
		r_pals=r_pals-6400;
		r++;
	}

	if(l_pals >= 6400){
		l_pals=l_pals-6400;
		l++;
	}
	
	r_distance = (r_pals/6400+r)*TC + r_distance;	/* E^C̐i񂾑[mm]̌vZ */
	l_distance = (l_pals/6400+l)*TC + l_distance;	/* ^C̐i񂾑[mm]̌vZ */
	
	/* pp̌vZ */
	om_old=om;
	om=(KoMIGI*(data.r<data.l)+KoHIDARI*(data.r>data.l))
		*(float)(data.r-data.l);			/*pxvZ*/
	self_th+=((om+om_old)*DT)/2.f;			/*[rad/s]*/
	
	/* px̒ */
	if(self_th<0.f){
		self_th+=PI*2;
	}
	if(self_th>=PI*2){
		self_th-=PI*2;
	}
	
	/* ␳ */
	if(mode == 1){
		if(th_now > target_th){
			rp--;
		}else if(th_now < target_th){
			rp++;
		}else if(th_now = target_th){
			rp=0;
		}
	
	}
	
	if(mode == 2){
		tar_pals = 0.03*tar_v*6400/(TC/10);
		if(tar_pals > data.r){
			rp++;
		}
		if(tar_pals < data.r){
			rp--;
		}
		if(CL * data.r > data.l * CR){
			lp++;
		}else if( CL * data.r < data.l * CR){
			lp--;
		}
	}
	
	if(mode == 3){
		tar_pals=0.03*tar_v*6400/(TC/10);
		if(tar_pals > data.l){
			lp++;
		}
		if(tar_pals < data.l){
			lp--;
		}
		if(CR * data.r > data.l * CL){
			rp--;
		}else if( CR * data.r < data.l * CL){
			rp++;
		}
	}
	
	if(mode == 4){
		
		tar_rv = tar_v;
		tar_lv = tar_v;
		
		if(sys9(6,15) == 0){
			sys8(6,16,r_distance/10);
			sys8(6,17,l_distance/10);
			sys8(6,15,1);
			
			rp = 0;
			lp = 0;
		}
		
		r_dis = tar_dis -(r_distance/10 - sys9(6,16));
		l_dis = tar_dis -(l_distance/10 - sys9(6,17));
		
		
		if(abs(r_distance/10 - sys9(6,16)) < 10){
			if(tar_dis > 0){
				tar_rv = r_distance/10 - sys9(6,16) + 1;
			}else if(tar_dis < 0){
				tar_rv = r_distance/10 - sys9(6,16) - 1;
			}
		
		}
		
		if(abs(l_distance/10 - sys9(6,17)) < 10){
			
			if(tar_dis > 0){
				tar_lv = l_distance/10 - sys9(6,17) + 1;
			}else if(tar_dis < 0){
				tar_lv = l_distance/10 - sys9(6,17) - 1;
			}
		
		}
		
		if(abs(r_dis) < 20){
			tar_rv = r_dis;
			
			if(r_dis == 0){
				rp = 0;
				
				sys8(6,18,1);
			}
		}
		
		if(abs(l_dis) < 20){
			tar_lv = l_dis;
			
			if(l_dis == 0){
				lp = 0;
				
				sys8(6,19,1);
			}
		}
		
		
		tar_rpals=0.03*tar_rv*6400/(TC/10);
		tar_lpals=0.03*tar_lv*6400/(TC/10);
		
		if(tar_rpals > data.r){
			rp++;
		}
		if(tar_rpals < data.r){
			rp--;
		}
		if(tar_lpals > data.l){
			lp++;
		}
		if(tar_lpals < data.l){
			lp--;
		}
		
		if(sys9(6,18) == 1 && sys9(6,19) == 1){
			sys8(6,11,0);
			sys8(6,15,0);
			
			sys8(6,18,0);
			sys8(6,19,0);
			rp = 0;
			lp = 0;
		}
	}
	
	
	sys8(6,1,ts_data);
	sys8(6,2,data.r);			/* E^C̃pX */
	sys8(6,3,data.l);			/* ^C̃pX */
	sys8(6,4,r_distance/10);	/* E^C̐i񂾑[cm] */
	sys8(6,5,l_distance/10);	/* ^C̐i񂾑[cm] */
	sys8(6,6,r_pals);			/* E[^̃pX */
	sys8(6,7,l_pals);			/* [^̃pX */
	sys8(6,8,r);				/* E^C̉] */
	sys8(6,9,l);				/* ^C̉] */
	sys8(6,10,(int)(self_th*DEG));	/* pp̓ */
	
	sys8(4,3,rp);				/* ␳ʂ̓ */
	sys8(4,4,lp);				/* ␳ʂ̓ */
	
	re_counter_reset();		/* [^[GR[_̐ώZJE^̃Zbg */
}

interrupt void intt06(){

}